package com.company;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
    private static List<Client> clients = new ArrayList<>();

    public static void main(String[] args) {

        AdminWrite adminWrite = new AdminWrite();
        adminWrite.start();

        try {
            ServerSocket ss = new ServerSocket(9125);

            while (true) {
                Socket clientSocket = ss.accept();

                try {
                    Client client = new Client(clientSocket, clients);
                    clients.add(client);
                    client.start();
                } catch (IOException e) {
                    System.out.println(e.getMessage());
                }
            }

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static class AdminWrite extends Thread {
        @Override
        public void run() {
            Scanner scanner = new Scanner(System.in);
            while (!isInterrupted()) {
                String message = scanner.nextLine();

                Transport t = new Transport();
                t.Name = "ADMIN";
                t.Message = message;
                for (Client client : clients) {
                    try {
                        client.outputStream.writeObject(t);
                        client.outputStream.flush();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }

}
